using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Printing;
using System.Threading;


namespace fall2015winhowtoprint
{
    public partial class Form1 : Form
    {
        static public int count = 0;
        static StreamReader streamToPrint;
        static Font printFont;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string line;
            string filename;
            OpenFileDialog ofd1 = new OpenFileDialog();
            ofd1.Multiselect = true;
            ofd1.ShowDialog();
            filename = ofd1.FileName;
            
            //print the file to the standard printer
            streamToPrint = new StreamReader(filename, System.Text.ASCIIEncoding.Default);
            //printFont = new Font("Time New Roman",12);
            printFont = new Font("Courier New", 12);
            PrintDocument pd = new PrintDocument();
            pd.PrintPage += new PrintPageEventHandler(this.pd_PrintPage);
            pd.Print();
            streamToPrint.Close();
        }

        private void pd_PrintPage(Object sender, PrintPageEventArgs e)
        {
            // Create the variables, that the print method uses
            float linesPerPage = 0;
            float yPos = 0;
            int count = 0;
            float leftMargin = e.MarginBounds.Left;
            float topMargin = e.MarginBounds.Top;
            string line = null;

            // Count the number of lines
            linesPerPage = e.MarginBounds.Height / printFont.GetHeight(e.Graphics);

            // prints the file line by line
            while (count < linesPerPage && ((line = streamToPrint.ReadLine()) != null))
            {
                yPos = topMargin + (count * printFont.GetHeight(e.Graphics));
                e.Graphics.DrawString(line, printFont, Brushes.Black, leftMargin, yPos, new StringFormat());
                count++;
            }

            // if more lines than one page, prints another page
            if (line != null)
                e.HasMorePages = true;
            else
                e.HasMorePages = false;
        }

    }
}